package zoltan.vari.spotify_mixer_discord_bot.config;

import discord4j.core.DiscordClient;
import discord4j.core.GatewayDiscordClient;
import discord4j.core.event.domain.interaction.ApplicationCommandInteractionEvent;
import discord4j.discordjson.json.ApplicationCommandRequest;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import zoltan.vari.spotify_mixer_discord_bot.eventListener.DiscordCommandService;

@Configuration
public class DiscordBotConfig {

    @Value( "${discord.bot.token}" )
    private String token;

    @Bean
    public DiscordClient discordClient(){
        return DiscordClient.create(token);
    }

    @Bean
    public GatewayDiscordClient gatewayDiscordClient(DiscordClient client, DiscordCommandService discordCommandService){
        GatewayDiscordClient gw = client.login().block();
        ApplicationCommandRequest greetCmdRequest = ApplicationCommandRequest.builder()
                .name(DiscordBotConstants.CREATE_SESSION_COMMAND)
                .description(DiscordBotConstants.CREATE_SESSION_DESCRIPTION)
                .build();
        client.getApplicationService()
                .createGlobalApplicationCommand(client.getApplicationId().block(), greetCmdRequest)
                .subscribe();


        gw.on(ApplicationCommandInteractionEvent.class, event -> {
            return discordCommandService.processCommand(gw,client,event);
        }).subscribe();

        return gw;
    }

}
