package zoltan.vari.spotify_mixer_discord_bot.eventListener;

import discord4j.common.util.Snowflake;
import discord4j.core.DiscordClient;
import discord4j.core.GatewayDiscordClient;
import discord4j.core.event.domain.interaction.ApplicationCommandInteractionEvent;
import discord4j.core.object.entity.Member;
import discord4j.core.object.entity.channel.PrivateChannel;
import discord4j.core.spec.InteractionApplicationCommandCallbackReplyMono;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.reactive.function.BodyInserters;
import org.springframework.web.reactive.function.client.WebClient;
import spotifymixerapi.api.CreateSessionRequest;
import spotifymixerapi.api.CreateSessionResponse;
import zoltan.vari.spotify_mixer_discord_bot.config.DiscordBotConstants;

import java.util.Collections;

@Service
public class DiscordCommandService {

    @Autowired
    private RestTemplate restTemplate;

    String BACK_END_BASE_URL = "http://localhost:15532";

    public InteractionApplicationCommandCallbackReplyMono processCommand(GatewayDiscordClient gw, DiscordClient client, ApplicationCommandInteractionEvent event){

        switch(event.getCommandName()){
            case DiscordBotConstants.CREATE_SESSION_COMMAND -> {
                return createSession(gw, client, event);
            }
            default -> {
                PrivateChannel userChannel = event.getInteraction().getUser().getPrivateChannel().block();
                client.getChannelById(userChannel.getId()).createMessage("test").block();
                return event.reply(event.toString());
            }
        }
    }

    private InteractionApplicationCommandCallbackReplyMono createSession(GatewayDiscordClient gw, DiscordClient client, ApplicationCommandInteractionEvent event) {
        PrivateChannel userChannel = event.getInteraction().getUser().getPrivateChannel().block();

        CreateSessionRequest createSessionRequest = new CreateSessionRequest();
        createSessionRequest.setDiscordUserId(event.getInteraction().getUser().getId().asString());
        createSessionRequest.setDiscordUserDisplayName(event.getInteraction().getUser().getGlobalName().orElse("unknown"));
        createSessionRequest.setDiscordUserName(event.getInteraction().getUser().getUsername());


        HttpHeaders headers = new HttpHeaders();
        headers.add("withCredentials","true");

        HttpEntity<CreateSessionRequest> entity = new HttpEntity<>(createSessionRequest, headers);



        CreateSessionResponse result = restTemplate.exchange(BACK_END_BASE_URL+"/session/create", HttpMethod.POST, entity, CreateSessionResponse.class).getBody();

        client.getChannelById(userChannel.getId()).createMessage(result.getUrl()).block();
        return event.reply("Session link sent to your DMs");
    }


}
